<?php
/**fostar_1qc Контроллер для "fostar_1qc" Компонета
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
require_once( JPATH_COMPONENT_SITE.DS.'ConfigClass.php' );
jimport('joomla.application.component.controller');

class fostar_1qcController extends JController {
    /**************************************************************************/
    /* Method to display the view МЕТОД ПО УМОЛЧАНИЮ!!! */
    /**************************************************************************/
    function display() {
        // включаем библиотеки js и таблицы стилей
        $this->addHeadLinkScript();
        // включаем header-таблицу компонента
        $this->addHeader();
        $viewName   = JRequest::getVar('view', 'catalogue', 'default', 'cmd');
        // Set the default view name from the Request
        $view = &$this->getView( $viewName, 'html');
        $tplName    = JRequest::getVar('fly');
        $cid        = JRequest::getVar('cid');
        $gid        = JRequest::getVar('gid');
        $model = &$this->getModel();
        if (!JError::isError( $model )) {
            $view->setModel( $model, true );
        }
        if($viewName=='catalogue') {
            if( $tplName == 'catalogue' ) {
                $view->setLayout('catalogue');
                $view->display( $cid, $gid );
            }else {
                $view->displayMain( $cid );
            }
        }else {
            $view->display($tplName);
        }
    }
    /**************************************************************************/
    /* запуск поиска по товарам */
    /**************************************************************************/
    function search() {
        // включаем библиотеки js и таблицы стилей
        $this->addHeadLinkScript();
        // включаем header-таблицу компонента
        $this->addHeader();
        $view = &$this->getView( 'catalogue', 'html');
        // Push a model into the view
        $model = &$this->getModel();
        if (!JError::isError( $model )) {
            $view->setModel( $model, true );
        }
        $view->displaySearchResult();
    }
    /**************************************************************************/
    /* получение информации */
    /**************************************************************************/
    function content() {
        // включаем библиотеки js и таблицы стилей
        $this->addHeadLinkScript();
        // включаем header-таблицу компонента
        $this->addHeader();
        $model = &$this->getModel();
        $pid   = JRequest::getVar( 'pid' );
        $model->PrintInfo($pid);
    }
    /**************************************************************************/
    /* при установленном параметре link=clear_cache контроллер очищает кэш */
    /**************************************************************************/
    function clear_cache() {
        // саму очистку было удобно реализовать в файле модели,
        // оттуда и запускаем
        $this->getModel()->clearCache();
        die();
    }
    /**************************************************************************/
    /* функция вызова скрипта AJAX добавления товаров в корзину */
    /**************************************************************************/
    function addToCart() {
        require_once JPATH_COMPONENT.DS.'ajax'.DS.'addToCart.php';
        $sess = JFactory::getSession();
        $sess->close();
        die();
    }
    /**************************************************************************/
    /* функция вызова скрипта AJAX малой проверки содержимого корзины */
    /**************************************************************************/
    function refreshCart() {
        require_once JPATH_COMPONENT.DS.'ajax'.DS.'refreshCart.php';
        die();
    }
    /**************************************************************************/
    /* функция вызова скрипта AJAX удаления товара из корзины */
    /**************************************************************************/
    function removeFromCart() {
        require_once JPATH_COMPONENT.DS.'ajax'.DS.'removeFromCart.php';
        $sess = JFactory::getSession();
        $sess->close();
        die();
    }
    /**************************************************************************/
    /* функция вызова скрипта AJAX изменения количества товара в корзине */
    /**************************************************************************/
    function refreshCounter() {
        require_once JPATH_COMPONENT.DS.'ajax'.DS.'refreshCounter.php';
        $sess = JFactory::getSession();
        $sess->close();
        die();
    }
    /**************************************************************************/
    /* заголовок компонента отображает:
     * меню быстрого перехода; поиск; информацию о партнере; состояние корзины
    /**************************************************************************/
    function addHeader() {
        $view = &$this->getView( 'catalogue', 'html');
        // Push a model into the view
        $model = &$this->getModel();
        if (!JError::isError( $model )) {
            $view->setModel( $model, true );
        }
        $view->displayHeader();
    }
    /**************************************************************************/
    /* функция дописывает необходимые библиотеки и таблицы стилей в <head> страницы: */
    /**************************************************************************/
    function addHeadLinkScript() {
        $document = &JFactory::getDocument();
        $data = file_get_contents(JPATH_COMPONENT.DS.'config.ini');
        $classname = 'ConfigClass';
        $config = new $classname();
        $config = unserialize(base64_decode($data));
        $document->addScript(                   $config->jsJQuery);
        $document->addScript(                   $config->jsSlimbox);
        $document->addStyleSheet(               $config->cssSlimbox);
        $document->addStyleSheet(               $config->cssFostar);
        $document->addScript(                   $config->jsFostar);
        $document->setMetaData('description',   $config->docDescription);
        $document->setMetaData('keywords',      $config->docKeywords);
        $document->setMetaData('EXPIRES','0',TRUE);
        $document->setMetaData('RESOURCE-TYPE','DOCUMENT');
        $document->setMetaData('DISTRIBUTION','GLOBAL');
        $document->setMetaData('RATING','GENERAL');
        $document->setBase(JRoute::_('index.php?option=com_fostar_1qc'));
    }
}
?>