<?php
/**fostar_1qc Представление "catalogue" для "fostar_1qc" Компонета
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view');

class fostar_1qcViewCatalogue extends JView {
    var $_config;
    function __construct() {
        $classname = 'ConfigClass';
        $this->_config = new $classname();
        $data = file_get_contents(JPATH_COMPONENT.DS.'config.ini');
        $this->_config = unserialize(base64_decode($data));

        parent::__construct();
    }
    
    function display($cid, $gid ) {
        // отображает подкаталоги, товары и карточку товара
        $document = & JFactory::getDocument();
        $document->setTitle( JText::_('Компонент Fostar-раскуси') );
        $model = $this->getModel();

        $uri =& JURI::getInstance();
        $version = new JVersion();
        $partner_url = $uri->toString(array('scheme', 'host', 'port'));
        $partner_clear_cache_url = base64_encode($partner_url . JRoute::_('index.php?option=com_fostar_1qc&link=clear_cache'));
        $partner_url = base64_encode($partner_url);
        $partner_cms = base64_encode($version->getLongVersion());
        $model->getResult("act=update_partner_info&partner_id={$this->_config->partnerID}&partner_cms=$partner_cms&partner_url=$partner_url&partner_clear_cache_url=$partner_clear_cache_url");

        $user_agent = base64_encode($_SERVER['HTTP_USER_AGENT']);
        $model->getResult("act=visitor_info&partner_id={$this->_config->partnerID}&REMOTE_ADDR={$_SERVER['REMOTE_ADDR']}&HTTP_X_FORWARDED_FOR={$_SERVER['HTTP_X_FORWARDED_FOR']}&HTTP_X_REAL_IP={$_SERVER['HTTP_X_REAL_IP']}&HTTP_USER_AGENT=$user_agent");

        if( isset($cid) ) {
            //список товаров в категории cid';
            // путь к каталогу
            $this->addCatTitle($model,$cid);
            // непосредственно товары
            $this->addItemsList($model,$cid);
        }
        if( isset($gid) ) {
            $this->addItem($model,$gid);
        }
        if(( !isset($cid) )&&( !isset($gid) )) {
            $this->addCatList($model,'act=categories');
        }
        parent::display();
    }
    function displayMain( $cid ) {
        // отображает главную страницу, родительские категории
        $model = $this->getModel();
        if( !isset($cid) ) {
            // главная
            // загружаем родительские категории
            $this->addCatList($model,'act=parents');
            // загружаем список новинок
            $this->addLatestList($model);
        }
        else {
            // дочерние:
            // путь к каталогу
            $this->addCatTitle($model,$cid);
            //загружаем дочерние подкатегории
            $cids = $this->addCatList($model,'act=childs&CID='.$cid);
            // загружаем список новинок
            $this->addLatestList($model,$cids);
        }

        parent::display();
    }
    function displayHeader() {
        $model = $this->getModel();
        $res = $model->getResult('act=categories');
        if($res != 'false') {
            $res = $model->makeArrayFromResult($res);
            $catList = array();
            for($ii=0; $ii<sizeof($res); $ii++) {
                $rez = $model->makeMainArrayFromResult($res[$ii]);
                $catList[$ii]['cid'] = $rez[0];
                $catList[$ii]['cname'] = $rez[1];
                $catList[$ii]['pid'] = $rez[2];
            }
            $this->assignRef('sCatList', $catList);
        }
        $partnerID = $this->_config->partnerID;
        $this->assignRef('partnerId', $partnerID);
        $searchString = JRequest::getVar('searchString');
        $this->assignRef('searchString', $searchString);
        parent::display('header');
    }
    function displaySearchResult() {
        $model = $this->getModel();
        $searchString = JRequest::getVar('searchString');
        if(isset($searchString)) {
            $this->assignRef('searchString', $searchString);
            if(strlen($searchString) <= 3) {
                $search_err='Слишком короткий запрос';
                $this->assignRef('search_err',$search_err );
            } else {
                if(isset($_SESSION['lastSearch'])) {
                    if($_SESSION['lastSearch'] > (time() - 10)) {
                        $search_err='Запрещено пользоваться поиском чаще одного раза в 10 секунд';
                        $this->assignRef('search_err',$search_err );
                    }else {
                        $this->addSearchResult($model,$searchString);
                        $_SESSION['lastSearch'] = time();
                    }
                }else {
                    $this->addSearchResult($model,$searchString);
                    $_SESSION['lastSearch'] = time();
                }
            }
        }
        parent::display('search_result');
    }
    function addSearchResult($model,$searchString) {
        $paginationLimit = $this->_config->paginationLimit;
        $limitstart = JRequest::getVar('limitstart');
        $KEY = md5('IT_IS_SECRET_KEY');
        $searchString = iconv("utf-8","windows-1251", $searchString);
        $res = $model->getResult('act=search&KEY='.$KEY.'&QUERY='.rawurlencode($searchString));
        if($res != 'false') {
            $res = $model->makeArrayFromResult($res);
            $gList = array();
            for($ii=0; $ii<sizeof($res); $ii++) {
                $rez = $model->makeMainArrayFromResult($res[$ii]);
                if(isset($rez[0]) && isset($rez[1]) && isset($rez[2]) && isset($rez[3]) && isset($rez[4])) {
                    $gList[$ii]['product_id'] = $rez[0];
                    $gList[$ii]['product_name'] = $rez[1];
                    $gList[$ii]['preview'] = $rez[2];
                    $gList[$ii]['price'] = $rez[3];
                    $gList[$ii]['special_price'] = $rez[4];
                    if(is_int(($ii+1) / 3)) {
                        $gList[$ii]['br'] = 'yes';
                    }
                }
            }
            jimport('joomla.html.pagination');
            $pagination = new JPagination(sizeof($gList), $limitstart, $paginationLimit);
            $this->assignRef('pagination',$pagination);
            $this->assignRef('gList', $gList);
        }else {
            $search_err='По вашему запросу ничего не найдено';
            $this->assignRef('search_err',$search_err );
        }
    }
    function addCatList($model,$q) {
        $res = $model->getResult($q);
        $cids = "";
        if($res != 'false') {
            $res = $model->makeArrayFromResult($res);
            $catList = array();
            for($ii=0; $ii<sizeof($res); $ii++) {
                $rez = $model->makeMainArrayFromResult($res[$ii]);
                $catList[$ii]['cid'] = $rez[0];
                $catList[$ii]['cname'] = $rez[1];
                $catList[$ii]['pid'] = $rez[2];
                if(is_int(($ii + 1) / 2)) {
                    $catList[$ii]['pos'] = 'right';
                }
                else {
                    $catList[$ii]['pos'] = 'left';
                }
                $cids .= $rez[0] . ":::";
            }
            $this->assignRef('catList', $catList);
        }
        return $cids;
    }
    function addLatestList($model,$cids = "") {
        // ПОЛУЧЕНИЕ СПИСКА НОВИНОК ТОВАРОВ
        $latestlimit = $this->_config->LatestLimit;
        if($cids!="") {
            $res = $model->getResult('act=latest&count='.$latestlimit.'&cids='.$cids);
        }else {
            $res = $model->getResult('act=latest&count='.$latestlimit);
        }
        if($res != 'false') {
            $res = $model->makeArrayFromResult($res);

            $nnList = array();

            for($ii=0; $ii<sizeof($res); $ii++) {
                $rez = $model->makeMainArrayFromResult($res[$ii]);
                $nnList[$ii]['product_id'] = $rez[0];
                $nnList[$ii]['product_name'] = $rez[1];
                $nnList[$ii]['preview'] = $rez[2];
                $nnList[$ii]['price'] = $rez[3];
                $nnList[$ii]['special_price'] = $rez[4];

                if(is_int(($ii+1) / 3)) {
                    $nnList[$ii]['br'] = 'yes';
                }
            }
            $this->assignRef('nnList', $nnList);
        }
    }
    function addCatTitle($model,$cid) {
        // дочерние
        $res = $model->getResult('act=categories&CID='.$cid);
        if($res != 'false') {
            $res = $model->makeArrayFromResult($res);
            $catTitle = array();
            for($ii=0; $ii<sizeof($res); $ii++) {
                $rez = $model->makeMainArrayFromResult($res[$ii]);
                $catTitle[$ii]['cid'] = $rez[0];
                $catTitle[$ii]['cname'] = $rez[1];
            }
            $this->assignRef('catTitle', $catTitle);
        }
    }
    function addItemsList($model,$cid) {
        $partnerID = $this->_config->partnerID;
        $paginationLimit = $this->_config->paginationLimit;
        $limitstart = JRequest::getVar('limitstart');
        $res = $model->getResult('act=goods&CID='.$cid.'&partner_id='.$partnerID);
        if($res != 'false') {
            $res = $model->makeArrayFromResult($res);
            $gList = array();
            for($ii=0; $ii<sizeof($res); $ii++) {
                $rez = $model->makeMainArrayFromResult($res[$ii]);
                if(isset($rez[0]) && isset($rez[1]) && isset($rez[2]) && isset($rez[3]) && isset($rez[4])) {
                    $gList[$ii]['product_id'] = $rez[0];
                    $gList[$ii]['product_name'] = $rez[1];
                    $gList[$ii]['preview'] = $rez[2];
                    $gList[$ii]['price'] = $rez[3];
                    $gList[$ii]['special_price'] = $rez[4];
                    $partner_addition = $rez[5] * 1;

                    if($partner_addition > 0) {
                        $gList[$ii]['price'] += $partner_addition;
                    }
                    if($partner_addition > 0 && $gList[$ii]['special_price'] != 'none') {
                        $gList[$ii]['special_price'] += $partner_addition;
                    }
                    if(is_int(($ii+1) / 3)) {
                        $gList[$ii]['br'] = 'yes';
                    }
                }
            }
            jimport('joomla.html.pagination');
            $pagination = new JPagination(sizeof($gList), $limitstart, $paginationLimit);
            $this->assignRef('pagination',$pagination);
            $this->assignRef('gList', $gList);
        }
    }
    function addItem($model,$gid) {
        $partnerID = $this->_config->partnerID;
        $res = $model->getResult('act=good&GID='.$gid.'&partner_id='.$partnerID);
        if($res != 'false') {
            $res = $model->makeMainArrayFromResult($res);
            $rez['pid']     = $res[0];
            $rez['pname']   = $res[1];
            $rez['preview'] = $res[2];
            $rez['photo']   = $res[3];
            $rez['price']   = $res[6];
            $rez['cid']     = $res[5];
            $rez['sprice']  = $res[4];
            $rez['cname']   = $res[7];
            $rez['descr']   = $res[8];
            $rez['order']   = $res[9];
            $rez['width']   = $res[10];
            $rez['height']  = $res[11];
            $rez['articul'] = $res[12];
            $partner_addition = $res[13] * 1;
            // атрибуты товара
            if (strlen($res[14])) {
                $prodAttr = json_decode(gzuncompress(stripslashes(base64_decode($res[14]))), true);
            } else {
                $prodAttr = array();
            }
            $prod_attribute=array();
            foreach ($prodAttr as $atKey=>$ValueArray){
                foreach ( $ValueArray as $valKey=>$val){
                    $newKey = base64_encode($atKey.':'.$val);
                    $newKey = str_replace('=', 'HfDYJ', $newKey);
                    $prod_attribute[$atKey][$newKey]=$val;
                }
            }
            $this->assignRef("prodAttr", $prod_attribute);
            // Надбавка партнера в цене
            if($partner_addition > 0 && $rez['price'] > 0) {
                $rez['price'] += $partner_addition;
            }
            if($partner_addition > 0 && $rez['sprice'] != 'none') {
                $rez['sprice'] += $partner_addition;
            }
            $rez['cartString'] = base64_encode($rez['pid'] . "::" . $rez['price']);
            $rez['cartString'] = str_replace('=', 'HfDYJ', $rez['cartString']);

            

            $season_action = $model->getResult('act=season_action');
            if ($season_action != 'false') {
                $season_action = $model->makeMainArrayFromResult($season_action);
                $rez['SEASON_ACTION_ENABLED'] = 1;
                $rez['SEASON_ACTION_CONTENT'] = $season_action[0];
                $rez['SEASON_ACTION_LINK_TEXT'] = $season_action[1];
            } else {
                $rez['SEASON_ACTION_ENABLED'] = 0;
            }
            $this->assignRef('rez',$rez);
            $title = '/' . $rez['cname'] . '/' . $rez['pname'];

            // Загрузка дополнительных фотографий
            $res = $model->getResult('act=photo&GID='.$gid);

            if($res != 'false') {
                $res = $model->makeArrayFromResult($res);
                $photo = array();

                for($ii=0; $ii<sizeof($res); $ii++) {
                    $rez2 = $model->makeMainArrayFromResult($res[$ii]);
                    $photo[$ii]['fid'] = $rez2[0];
                    $photo[$ii]['ftitle'] = $rez2[1];
                    $photo[$ii]['furl'] = $rez2[2];
                    $photo[$ii]['fwidth'] = $rez2[3];
                    $photo[$ii]['fheight'] = $rez2[4];
                    $photo[$ii]['ftwidth'] = $rez2[5];
                    $photo[$ii]['ftheight'] = $rez2[6];
                }
                $this->assignRef("photoes", $photo);

            }

            // Загрузка похожих товаров
            $res = $model->getResult('act=relations&GID='.$gid);

            if($res != 'false') {
                $res = $model->makeArrayFromResult($res);
                $relations = array();

                for($ii=0; $ii<sizeof($res); $ii++) {
                    $rez2 = $model->makeMainArrayFromResult($res[$ii]);
                    $relations[$ii]['pid'] = $rez2[0];
                    $relations[$ii]['pname'] = $rez2[1];
                    $relations[$ii]['preview'] = $rez2[2];
                    if(is_int(($ii + 1) / 5)) {
                        $relations[$ii]['br'] = 'yes';
                    }
                }
                $this->assignRef("relations", $relations);
            }
        }
    }
}
?>
